*********************************************************************
*									 *
*	 This file contains the	special	Z-80 simulation	routines and	 *
*	 the Morrow HDC/DMA support routines.				 *
*									 *
*************************************************************************

	 globl preED,outspec
	 xdef mloop,illegl

return	  equ @16,r	 ; JMP (return)	is fast	return to MLOOP.
pseudopc equ @15,r	 ; 8080's PC is	register A5.
opptr	  equ @14,r	 ; Pointer to opcode dispatch table.
pseudosp equ @13,r	 ; 8080's SP is	register A3.
flagptr  equ @12,r	 ; Pointer to 8080's flag lookup table is A2.
targbase equ @11,r	 ; Pointer to 8080's address space is A1.
regs	  equ @11,r	 ; Base	pointer	to 8080's registers is A1.

regcon0e equ 7,r	 ; Register based constant #$E (for speed).
regcon01 equ 6,r	 ; Register based constant #$1.
regcon0f equ 5,r	 ; Register based constant #$F.
regconff equ 4,r	 ; Register based constant #$FF.
regf	  equ 3,r	 ; 8080's Flags
rega	  equ 2,r	 ; 8080's Accumulator

regr	 equ -$f
regi	 equ -$e
regiy	 equ -$c
regix	 equ -$a
regb	 equ -8		 ; Offsets from	register base pointer for
regc	 equ -7		 ; 8080's pseudo-registers.
regd	 equ -6		 ; A & F are in	Data Registers.
rege	 equ -5		 ; Pseudo-PC is	kept in	an Address Register.
regh	 equ -4
regl	 equ -3
regop1	 equ -2		 ; Operand 1 for DAA storage
regop2	 equ -1		 ;    "	   2  "	  "	"


	 data
	 page
*************************************************************************
*									 *
*	 Opcode	dispatch table.	 One longword entry per	opcode of the	 *
*	 target	(Z-80) processor, including illegals.			 *
*									 *
*************************************************************************
*									 *
*	 Only a	few of the most	popular	instructions are simulated.	 *
*	 Support for the Z-80 Block move instructions is provided	 *
*	 as the	flags for this simulation resemble those of the	Z-80	 *
*	 rather	than the 8080.	Certain	packages (notably BDS-C) check	 *
*	 the flags and mistakenly assume a Z-80, then use LDIR/LDDR.	 *
*	 Therefore, minimal Z-80 support is provided for these		 *
*	 instructions.	By no means is this a complete simulation	 *
*	 of the	Z-80.							 *
*									 *
*************************************************************************


	 even
	 data
EDoptab dc.l 0,0,0,0,0,0,0,0		 ; ED00
	 dc.l 0,0,0,0,0,0,0,0
	 dc.l 0,0,0,0,0,0,0,0		 ; ED10
	 dc.l 0,0,0,0,0,0,0,0
	 dc.l 0,0,0,0,0,0,0,0		 ; ED20
	 dc.l 0,0,0,0,0,0,0,0
	 dc.l 0,0,0,0,0,0,0,0		 ; ED30
	 dc.l 0,0,0,0,0,0,0,0
	 dc.l 0,0,sbcbc,stbcd,nega,0,0,ldia	 ; ED40
	 dc.l 0,0,adcbc,ldbcd,0,0,0,ldra
	 dc.l 0,0,sbcde,sded,0,0,0,ldai		 ; ED50
	 dc.l 0,0,adcde,ldded,0,0,0,ldar
	 dc.l 0,0,sbchl,0,0,0,0,rrd		 ; ED60
	 dc.l 0,0,adchl,0,0,0,0,rld
	 dc.l 0,0,sbcsp,sspd,0,0,0,0		 ; ED70
	 dc.l 0,0,adcsp,ldspd,0,0,0,0
	 dc.l 0,0,0,0,0,0,0,0		 ; ED80
	 dc.l 0,0,0,0,0,0,0,0
	 dc.l 0,0,0,0,0,0,0,0		 ; ED90
	 dc.l 0,0,0,0,0,0,0,0
	 dc.l ldi,0,0,0,0,0,0,0		 ; EDA0
	 dc.l ldd,0,0,0,0,0,0,0
	 dc.l ldir,cpir,0,0,0,0,0,0	 ; EDB0
	 dc.l lddr,0,0,0,0,0,0,0
	 dc.l 0,0,0,0,0,0,0,0		 ; EDC0
	 dc.l 0,0,0,0,0,0,0,0
	 dc.l 0,0,0,0,0,0,0,0		 ; EDD0
	 dc.l 0,0,0,0,0,0,0,0
	 dc.l 0,0,0,0,0,0,0,0		 ; EDE0
	 dc.l 0,0,0,0,0,0,0,0
	 dc.l 0,0,0,0,0,0,0,0		 ; EDF0
	 dc.l 0,0,0,0,0,0,0,0

	 page
	 text
preED	 moveq #0,d1			 ; Zero-fill high bits.
	 move.b	(pseudopc)+,d1		 ; Grab	next opcode.
	 asl #2,d1
	 lea.l EDoptab,a0
	 move.l	0(a0,d1.w),-(sp)	 ; Do the operation.
	 beq illgED
	 rts

illgED	 move.l	(sp)+,d1		 ; Trash the address,
	 dec.l pseudopc			 ; fix PPC for ILLEGAL.
	 bra illegl


	 page
*************************************************************************
*									 *
*	 Z-80 opcode simulation	routines.				 *
*									 *
*************************************************************************

ldi:	move.w	regh(regs),d0
	move.w	regd(regs),d1
	move.b	0(targbase,d0.w),0(targbase,d1.w)
	add.w	#1,regh(regs)
	add.w	#1,regd(regs)
	sub.w	#1,regb(regs)
	beq	ldiv			; P/V flag clear when BC-1=0
	move	#$4,regf
	jmp	(return)
ldiv:	move	#0,regf
	jmp	(return)

ldir	 move.l	d2,-(sp)
	 move.w	regb(regs),d0		 ; Grab	count,
	 dec.w d0			 ; adjust for DBRA later.
	 moveq #0,d1
	 moveq #0,d2
	 move.w	regh(regs),d1		 ; Grab	source.
	 move.w	regd(regs),d2		 ; Grab	dest.
	 move.l	a5,-(sp)		 ; Need	an address reg.
	 lea.l 0(targbase,d2.l),a5
	 lea.l 0(targbase,d1.l),a0
ldirlop move.b	(a0)+,(a5)+
	 inc.w d1
	 inc.w d2
	 dbra d0,ldirlop
	 move.l	(sp)+,a5
	 move.w	d1,regh(regs)		 ; Restore result registers.
	 move.w	d2,regd(regs)
	 move.w	#0,regb(regs)
	 moveq #0,regf
	 move.l	(sp)+,d2
	 jmp (return)

ldd:	move.w	regh(regs),d0
	move.w	regd(regs),d1
	move.b	0(targbase,d0.w),0(targbase,d1.w)
	sub.w	#1,regh(regs)
	sub.w	#1,regd(regs)
	sub.w	#1,regb(regs)
	beq	lddv			; P/V flag clear when BC-1=0
	move	#$4,regf
	jmp	(return)
lddv:	move	#0,regf
	jmp	(return)


lddr	 move.l	d2,-(sp)
	 move.w	regb(regs),d0		 ; Grab	count,
	 dec.w d0			 ; adjust for DBRA later.
	 moveq #0,d1
	 moveq #0,d2
	 move.w	regh(regs),d1		 ; Grab	source.
	 move.w	regd(regs),d2		 ; Grab	dest.
	 move.l	a5,-(sp)		 ; Need	an address reg.
	 lea.l 1(targbase,d2.l),a5
	 lea.l 1(targbase,d1.l),a0
lddrlop move.b	-(a0),-(a5)
	 dec.w d1
	 dec.w d2
	 dbra d0,lddrlop
	 move.l	(sp)+,a5
	 move.w	d1,regh(regs)		 ; Restore result registers.
	 move.w	d2,regd(regs)
	 move.w	#0,regb(regs)
	 moveq #0,regf
	 move.l	(sp)+,d2
	 jmp (return)

	 page
cpir:	 move.w	regb(regs),d0		 ; Grab	count,
	 dec.w d0			 ; adjust for DBRA later.
	 moveq #0,d1
	 move.w	regh(regs),d1		; grab source
	lea.l	0(targbase,d1.l),a0
cpirlop: inc.w	d1
	cmp.b	(a0)+,rega
	dbeq	d0,cpirlop
	seq	regf
	move.w	d1,regh(regs)		; Restore result registers
	inc.w	d0
	move.w	d0,regb(regs)
	tst.b	regf
	bne	cpir1
	moveq	#0,regf			; not found
	jmp	(return)
cpir1:	tst	d0
	beq	cpir2
	moveq	#$44,regf		; Found, in the string
	jmp	(return)
cpir2:	moveq	#$40,regf		; Found, but at last place
	jmp	(return)

ldbcd:	move.b	1(pseudopc),-(sp)	; ED 4B Ld BC,(nn)
	move.w	(sp)+,d0
	move.b	(pseudopc),d0
	addq.l	#2,pseudopc
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(a0)+,regc(regs)
	move.b	(a0),regb(regs)
	jmp	(return)

ldded:	move.b	1(pseudopc),-(sp)	; ED 5B Ld DE,(nn)
	move.w	(sp)+,d0
	move.b	(pseudopc),d0
	addq.l	#2,pseudopc
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(a0)+,rege(regs)
	move.b	(a0),regd(regs)
	jmp	(return)

ldspd	move.b	1(pseudopc),-(sp)		; ED 7B Ld SP,(nn)
	move.w	(sp)+,d0
	move.b	(pseudopc),d0
	addq.l	#2,pseudopc
	move.l	d0,a0
	add.l	targbase,a0
	move.b	1(a0),-(sp)
	move.w	(sp)+,d0
	move.b	(a0),d0
	move.l	d0,pseudosp
	add.l	targbase,pseudosp
	jmp	(return)



stbcd	move.b	1(pseudopc),-(sp)		; ED 43 Ld (nn),BC
	move.w	(sp)+,d0
	move.b	(pseudopc),d0
	addq.l	#2,pseudopc
	move.l	d0,a0
	add.l	targbase,a0
	move.b	regc(regs),(a0)+
	move.b	regb(regs),(a0)
	jmp	(return)

sded	move.b	1(pseudopc),-(sp)		; ED 53 Ld (nn),DE
	move.w	(sp)+,d0
	move.b	(pseudopc),d0
	addq.l	#2,pseudopc
	move.l	d0,a0
	add.l	targbase,a0
	move.b	rege(regs),(a0)+
	move.b	regd(regs),(a0)
	jmp	(return)

sspd	move.b	1(pseudopc),-(sp)		; ED 73 Ld (nn),SP
	move.w	(sp)+,d0
	move.b	(pseudopc),d0
	addq.l	#2,pseudopc
	move.l	d0,a0
	add.l	targbase,a0
	move.l	pseudosp,d0
	sub.l	targbase,d0
	move.b	d0,(a0)+
	move.w	d0,-(sp)
	move.b	(sp)+,(a0)
	jmp	(return)

rrd:	move.l	d7,-(sp)			; ED 67 Rrd
	clr.l	d7
	move.w	regh(regs),d7
	move.b	(targbase,d7.l),d1	* d1 = (hl)
	and.w	#$f,d1
	move	rega,d0
	and.w	#$f0,d0
	or	d1,d0
	move	d0,-(sp)		* save new rega
	move.b	(targbase,d7.l),d1
	lsr.b	#4,d1
	and.w	#$f,rega
	lsl.b	#4,rega
	or.b	rega,d1
	and.b	#$3f,regf
	move.b	d1,(targbase,d7.l)	* store new (hl)
	bne	rrdnz
	bset	#6,regf
rrdnz:	bpl	rrdpl
	bset	#7,regf
rrdpl:	move	(sp)+,rega
	move.l	(sp)+,d7
	jmp	(return)

rld:	move.l	d7,-(sp)			; ED 6F rld
	clr.l	d7
	move.w	regh(regs),d7
	move.b	(targbase,d7.l),d1	* d1 = (hl)
	lsr.b	#4,d1
	move	rega,d0
	and.w	#$f0,d0
	or	d1,d0
	move	d0,-(sp)		* save new rega
	move.b	(targbase,d7.l),d1
	lsl.b	#4,d1
	and.w	#$f,rega
	or.b	rega,d1
	and.b	#$3f,regf
	move.b	d1,(targbase,d7.l)	* store new (hl)
	bne	rldnz
	bset	#6,regf
rldnz:	bpl	rldpl
	bset	#7,regf
rldpl:	move	(sp)+,rega
	move.l	(sp)+,d7
	jmp	(return)

*************************************************************************
*									*
*	Z-80 16 bit arithmetic routines					*
*									*
*************************************************************************

sbcbc	asr.b	#1,regf				; ED 42 Sbc hl,bc w/carry
	move.w	regb(regs),d0
	move.w	regh(regs),d1
	subx.w	d0,d1
	move	sr,d0
	move.w	d1,regh(regs)
	bra	doflag

sbcde	asr.b	#1,regf				; ED 52 Sbc hl,de w/carry
	move.w	regd(regs),d0
	move	regh(regs),d1
	subx.w	d0,d1
	move	sr,d0
	move	d1,regh(regs)
	bra	doflag

sbchl	asr.b	#1,regf				; ED 62 Sbc hl,hl w/carry
	move.w	regh(regs),d1
	moveq	#0,d0
	subx.w	d1,d1
	move	sr,d0
	move	d1,regh(regs)
	bra	doflag

sbcsp	asr.b	#1,regf				; ED 72 Sbc hl,sp w/carry
	move.l	pseudosp,d0
	sub.l	targbase,d0
	move	regh(regs),d1
	subx.w	d0,d1
	move	sr,d0
	move	d1,regh(regs)
	bra	doflag

doflag	and.w	regcon0f,d0
	move.b	(flagptr,d0.w),regf
	jmp	(return)

adcbc	asr.b	#1,regf				; ED 4A Adc hl,bc w/carry
	move.w	regb(regs),d0
	move	regh(regs),d1
	addx.w	d0,d1
	move	sr,d0
	move	d1,regh(regs)
	bra	doflag

adcde	asr.b	#1,regf				; ED 5A Adc hl,de w/carry
	move.w	regd(regs),d0
	move	regh(regs),d1
	addx.w	d0,d1
	move	sr,d0
	move	d1,regh(regs)
	bra	doflag

adchl	asr.b	#1,regf				; ED 6A Adc hl,hl w/carry
	move.w	regh(regs),d1
	moveq	#0,d0
	addx.w	d1,d1
	move	sr,d0
	move	d1,regh(regs)
	bra	doflag

adcsp	asr.b	#1,regf				; ED 7A Adc hl,sp w/carry
	move.l	pseudosp,d0
	sub.l	targbase,d0
	move	regh(regs),d1
	addx.w	d0,d1
	move	sr,d0
	move	d1,regh(regs)
	bra	doflag

*	Z-80 8 bit-loads

ldai	move.b	regi(regs),rega			; ED 57 Ld A,I
	jmp	(return)

ldar	move.b	regr(regs),rega			; ED 5F Ld A,R
	jmp	(return)

ldia	move.b	rega,regi(regs)			; ED 47 Ld I,A
	jmp	(return)

ldra	move.b	rega,regr(regs)			; ED 4F Ld R,A
	jmp	(return)

nega	neg.b	rega				; ED 44 Neg A
	move	sr,d0
	and.w	regcon0f,d0
	move.b	(flagptr,d0.w),regf
	jmp	(return)

	 page
*************************************************************************
*									 *
*	 Output	instruction simulator for Morrow HDDMA			 *
*									 *
*************************************************************************


outspec move.l	d3,-(sp)
	 cmp.b #$55,d0
	 beq hdstart			 ; Start command?  Do it,
	 move.l	#hdbuf,d1		 ; else	build first link to host buffer
	 move.l	#$50,a0			 ; if it's a HDRESET command.
	 move.b	d1,(a0)+
	 ror.l #8,d1
	 move.b	d1,(a0)+
	 ror.l #8,d1
	 move.b	d1,(a0)+

	 move.l	#$ff0000,a0		 ; Do the output to HDDMA.
	 adda.l	d0,a0
	 move.b	rega,(a0)
	 move.l	(sp)+,d3
	 jmp (return)

hdstart move.l	dmalink,a0		 ; Move	target buffer to host buffer, do
	 adda.l	targbase,a0		 ; all appropriate patching of addresses.
	 moveq #0,d1
	 move.b	(a0)+,d1		 ; Get link address.
	 ror.l #8,d1
	 move.b	(a0)+,d1
	 ror.l #8,d1
	 move.b	(a0)+,d1
	 rol.l #8,d1
	 rol.l #8,d1
	 move.l	d1,a0
	 adda.l	targbase,a0
	 move.l	a6,-(sp)
	 lea.l hdbuf,a6
	 move.w	#3,d1
hdloop	 move.b	(a0)+,(a6)+
	 dbra d1,hdloop
	 moveq #0,d3			 ; Fix DMA address to -> target	area.
	 move.b	(a0)+,d3
	 ror.l #8,d3
	 move.b	(a0)+,d3
	 ror.l #8,d3
	 move.b	(a0)+,d3
	 rol.l #8,d3
	 rol.l #8,d3
	 add.l targbase,d3
	 move.b	d3,(a6)+
	 ror.l #8,d3
	 move.b	d3,(a6)+
	 ror.l #8,d3
	 move.b	d3,(a6)+
	 move.w	#5,d1			 ; Move	rest of	command	buffer.
hdloop2 move.b	(a0)+,(a6)+
	 dbra d1,hdloop2

	 move.l	#hdbuf,d1
	 move.b	d1,(a6)+		 ; Point host buffer to	self.
	 ror.l #8,d1
	 move.b	d1,(a6)+
	 ror.l #8,d1
	 move.b	d1,(a6)+
	 move.l	(sp)+,a6
	 move.l	a0,-(sp)		 ; Save	STATUS address for return val.
	 suba.l	targbase,a0
	 move.l	a0,dmalink		 ; Stash new target link address.
	
	 move.l	#$ff0000,a0		 ; Do the output to HDDMA.
	 adda.l	d0,a0
	 move.b	rega,(a0)

	 move.l	#hdbuf+12,a0		 ; Wait	for completion
hdloop3 tst.b (a0)
	 beq hdloop3			 ; Fragile, but	what do	you want for $1.00?
	 move.b	(a0),d1
	 move.l	(sp)+,a0		 ; Grab	the STATUS address in target space.
	 move.b	d1,-(a0)		 ; And stash status for	it.
	 move.l	(sp)+,d3
	 jmp (return)			 ; Return to simulation.

	 data
	 even

dmalink dc.l $50		 ; Storage for current HDDMA command buffer.
hdbuf	 ds.b 16

	 end
n to simulation.

	 data
	 even

dmalink dc.l $50		 ; Storage for current HDDMA command buffer.
hdbuf	 ds.b 16

	 end
