*********************************************************************
*									 *
*	 This file contains the	special	Z-80 simulation	routines and	 *
*	 the Morrow HDC/DMA support routines.				 *
*									 *
*************************************************************************

	 globl preCB
	 xdef mloop,illegl

return	  equ @16,r	 ; JMP (return)	is fast	return to MLOOP.
pseudopc equ @15,r	 ; 8080's PC is	register A5.
opptr	  equ @14,r	 ; Pointer to opcode dispatch table.
pseudosp equ @13,r	 ; 8080's SP is	register A3.
flagptr  equ @12,r	 ; Pointer to 8080's flag lookup table is A2.
targbase equ @11,r	 ; Pointer to 8080's address space is A1.
regs	  equ @11,r	 ; Base	pointer	to 8080's registers is A1.

regcon0e equ 7,r	 ; Register based constant #$E (for speed).
regcon01 equ 6,r	 ; Register based constant #$1.
regcon0f equ 5,r	 ; Register based constant #$F.
regconff equ 4,r	 ; Register based constant #$FF.
regf	  equ 3,r	 ; 8080's Flags
rega	  equ 2,r	 ; 8080's Accumulator

regiy	 equ -$c
regix	 equ -$a
regb	 equ -8		 ; Offsets from	register base pointer for
regc	 equ -7		 ; 8080's pseudo-registers.
regd	 equ -6		 ; A & F are in	Data Registers.
rege	 equ -5		 ; Pseudo-PC is	kept in	an Address Register.
regh	 equ -4
regl	 equ -3
regop1	 equ -2		 ; Operand 1 for DAA storage
regop2	 equ -1		 ;    "	   2  "	  "	"


	 data
	 page
*************************************************************************
*									 *
*	 Opcode	dispatch table.	 One longword entry per	opcode of the	 *
*	 target	(Z-80) processor, including illegals.			 *
*									 *
*************************************************************************
*									 *
*	 Only a	few of the most	popular	instructions are simulated.	 *
*	 Support for the Z-80 Block move instructions is provided	 *
*	 as the	flags for this simulation resemble those of the	Z-80	 *
*	 rather	than the 8080.	Certain	packages (notably BDS-C) check	 *
*	 the flags and mistakenly assume a Z-80, then use LDIR/LDDR.	 *
*	 Therefore, minimal Z-80 support is provided for these		 *
*	 instructions.	By no means is this a complete simulation	 *
*	 of the	Z-80.							 *
*									 *
*************************************************************************

	 even
CBoptab  dc.l rlcb,rlcc,rlcd,rlce,rlch,rlcl,rlcm,rlca		 ; CB00
	 dc.l rrcb,rrcc,rrcd,rrce,rrch,rrcl,rrcm,rrca
	 dc.l rlb,rlc,rld,rle,rlh,rll,rlm,rla			 ; CB10
	 dc.l rrb,rrc,rrd,rre,rrh,rrl,rrm,rra
	 dc.l slab,slac,slad,slae,slah,slal,slam,slaa		 ; CB20
	 dc.l srab,srac,srad,srae,srah,sral,sram,sraa
	 dc.l 0,0,0,0,0,0,0,0					 ; CB30
	 dc.l srlb,srlc,srld,srle,srlh,srll,srlm,srla
	 dc.l bitb0,bitc0,bitd0,bite0,bith0,bitl0,bithl0,bita0	 ; CB40
	 dc.l bitb1,bitc1,bitd1,bite1,bith1,bitl1,bithl1,bita1	 ;
	 dc.l bitb2,bitc2,bitd2,bite2,bith2,bitl2,bithl2,bita2	 ; CB50
	 dc.l bitb3,bitc3,bitd3,bite3,bith3,bitl3,bithl3,bita3	 ;
	 dc.l bitb4,bitc4,bitd4,bite4,bith4,bitl4,bithl4,bita4	 ; CB60
	 dc.l bitb5,bitc5,bitd5,bite5,bith5,bitl5,bithl5,bita5	 ;
	 dc.l bitb6,bitc6,bitd6,bite6,bith6,bitl6,bithl6,bita6	 ; CB70
	 dc.l bitb7,bitc7,bitd7,bite7,bith7,bitl7,bithl7,bita7	 ;

	 dc.l resb0,resc0,resd0,rese0,resh0,resl0,reshl0,resa0	 ; CB80
	 dc.l resb1,resc1,resd1,rese1,resh1,resl1,reshl1,resa1	 ;
	 dc.l resb2,resc2,resd2,rese2,resh2,resl2,reshl2,resa2	 ; CB90
	 dc.l resb3,resc3,resd3,rese3,resh3,resl3,reshl3,resa3	 ;
	 dc.l resb4,resc4,resd4,rese4,resh4,resl4,reshl4,resa4	 ; CBA0
	 dc.l resb5,resc5,resd5,rese5,resh5,resl5,reshl5,resa5	 ;
	 dc.l resb6,resc6,resd6,rese6,resh6,resl6,reshl6,resa6	 ; CBB0
	 dc.l resb7,resc7,resd7,rese7,resh7,resl7,reshl7,resa7	 ;

	 dc.l setb0,setc0,setd0,sete0,seth0,setl0,sethl0,seta0	 ; CBC0
	 dc.l setb1,setc1,setd1,sete1,seth1,setl1,sethl1,seta1	 ;
	 dc.l setb2,setc2,setd2,sete2,seth2,setl2,sethl2,seta2	 ; CBD0
	 dc.l setb3,setc3,setd3,sete3,seth3,setl3,sethl3,seta3	 ;
	 dc.l setb4,setc4,setd4,sete4,seth4,setl4,sethl4,seta4	 ; CBE0
	 dc.l setb5,setc5,setd5,sete5,seth5,setl5,sethl5,seta5	 ;
	 dc.l setb6,setc6,setd6,sete6,seth6,setl6,sethl6,seta6	 ; CBF0
	 dc.l setb7,setc7,setd7,sete7,seth7,setl7,sethl7,seta7	 ;

	 page
	 text
preCB	 moveq #0,d1			 ; Zero-fill high bits.
	 move.b	(pseudopc)+,d1		 ; Grab	next opcode.
	 asl #2,d1
	 lea.l CBoptab,a0
	 move.l	0(a0,d1.w),-(sp)	 ; Do the operation.
	 beq illgCB
	 rts

illgCB	 move.l	(sp)+,d1		 ; Trash the address,
	 dec.l pseudopc			 ; fix PPC for ILLEGAL.
	 bra illegl

*************************************************************************
*									*
*	Z-80 bit test, set, reset routines				*
*									*
*************************************************************************


bita0	btst	#0,rega			; CB 47 Bit a,0
dozfl	beq	zset
	bclr	#6,regf
	jmp	(return)
zset	bset	#6,regf
	jmp	(return)

bitb0	btst	#0,regb(regs)			; CB 40 Bit b,0
	bra	dozfl

bitc0	btst	#0,regc(regs)			; CB 41 Bit c,0
	bra	dozfl

bitd0	btst	#0,regd(regs)			; CB 42 Bit d,0
	bra	dozfl

bite0	btst	#0,rege(regs)			; CB 43 Bit e,0
	bra	dozfl

bith0	btst	#0,regh(regs)			; CB 44 Bit h,0
	bra	dozfl

bitl0	btst	#0,regl(regs)			; CB 45 Bit l,0
	bra	dozfl

bithl0	move.w	regh(regs),d0			; CB 46 Bit (hl),0
	btst	#0,(targbase,d0.l)
	bra	dozfl

bita1	btst	#1,rega			; CB 4F Bit a,1
	bra	dozfl

bitb1	btst	#1,regb(regs)			; CB 48 Bit b,1
	bra	dozfl

bitc1	btst	#1,regc(regs)			; CB 49 Bit c,1
	bra	dozfl

bitd1	btst	#1,regd(regs)			; CB 4A Bit d,1
	bra	dozfl

bite1	btst	#1,rege(regs)			; CB 4B Bit e,1
	bra	dozfl

bith1	btst	#1,regh(regs)			; CB 4C Bit h,1
	bra	dozfl

bitl1	btst	#1,regl(regs)			; CB 4D Bit l,1
	bra	dozfl

bithl1	move.w	regh(regs),d0			; CB 4E Bit (hl),1
	btst	#1,(targbase,d0.l)
	bra	dozfl

bita2	btst	#2,rega			; CB 57 Bit a,2
	bra	dozfl

bitb2	btst	#2,regb(regs)			; CB 50 Bit b,2
	bra	dozfl

bitc2	btst	#2,regc(regs)			; CB 51 Bit c,2
	bra	dozfl

bitd2	btst	#2,regd(regs)			; CB 52 Bit d,2
	bra	dozfl

bite2	btst	#2,rege(regs)			; CB 53 Bit e,2
	bra	dozfl

bith2	btst	#2,regh(regs)			; CB 54 Bit h,2
	bra	dozfl

bitl2	btst	#2,regl(regs)			; CB 55 Bit l,2
	bra	dozfl

bithl2	move.w	regh(regs),d0			; CB 56 Bit (hl),2
	btst	#2,(targbase,d0.l)
	bra	dozfl

bita3	btst	#3,rega			; CB 5F Bit a,3
	bra	dozfl

bitb3	btst	#3,regb(regs)			; CB 58 Bit b,3
	bra	dozfl

bitc3	btst	#3,regc(regs)			; CB 59 Bit c,3
	bra	dozfl

bitd3	btst	#3,regd(regs)			; CB 5A Bit d,3
	bra	dozfl

bite3	btst	#3,rege(regs)			; CB 5B Bit e,3
	bra	dozfl

bith3	btst	#3,regh(regs)			; CB 5C Bit h,3
	bra	dozfl

bitl3	btst	#3,regl(regs)			; CB 5D Bit l,3
	bra	dozfl

bithl3	move	regh(regs),d0			; CB 5E Bit (hl),3
	btst	#3,(targbase,d0.l)
	bra	dozfl

bita4	btst	#4,rega			; CB 67 Bit a,4
	bra	dozfl

bitb4	btst	#4,regb(regs)			; CB 60 Bit b,4
	bra	dozfl

bitc4	btst	#4,regc(regs)			; CB 61 Bit c,4
	bra	dozfl

bitd4	btst	#4,regd(regs)			; CB 62 Bit d,4
	bra	dozfl

bite4	btst	#4,rege(regs)			; CB 63 Bit e,4
	bra	dozfl

bith4	btst	#4,regh(regs)			; CB 64 Bit h,4
	bra	dozfl

bitl4	btst	#4,regl(regs)			; CB 65 Bit l,4
	bra	dozfl

bithl4	move.w	regh(regs),d0			; CB 66 Bit (hl),4
	btst	#4,(targbase,d0.l)
	bra	dozfl

bita5	btst	#5,rega			; CB 6F Bit a,5
	bra	dozfl

bitb5	btst	#5,regb(regs)			; CB 68 Bit b,5
	bra	dozfl

bitc5	btst	#5,regc(regs)			; CB 69 Bit c,5
	bra	dozfl

bitd5	btst	#5,regd(regs)			; CB 6A Bit d,5
	bra	dozfl

bite5	btst	#5,rege(regs)			; CB 6B Bit e,5
	bra	dozfl

bith5	btst	#5,regh(regs)			; CB 6C Bit h,5
	bra	dozfl

bitl5	btst	#5,regl(regs)			; CB 6D Bit l,5
	bra	dozfl

bithl5	move	regh(regs),d0			; CB 6E Bit (hl),5
	btst	#5,(targbase,d0.l)
	bra	dozfl

bita6	btst	#6,rega			; CB 77 Bit a,6
	bra	dozfl

bitb6	btst	#6,regb(regs)			; CB 70 Bit b,6
	bra	dozfl

bitc6	btst	#6,regc(regs)			; CB 71 Bit c,6
	bra	dozfl

bitd6	btst	#6,regd(regs)			; CB 72 Bit d,6
	bra	dozfl

bite6	btst	#6,rege(regs)			; CB 73 Bit e,6
	bra	dozfl

bith6	btst	#6,regh(regs)			; CB 74 Bit h,6
	bra	dozfl

bitl6	btst	#6,regl(regs)			; CB 75 Bit l,6
	bra	dozfl

bithl6	move	regh(regs),d0			; CB 76 Bit (hl),6
	btst	#6,(targbase,d0.l)
	bra	dozfl

bita7	btst	#7,rega			; CB 7F Bit a,7
	bra	dozfl

bitb7	btst	#7,regb(regs)			; CB 78 Bit b,7
	bra	dozfl

bitc7	btst	#7,regc(regs)			; CB 79 Bit c,7
	bra	dozfl

bitd7	btst	#7,regd(regs)			; CB 7A Bit d,7
	bra	dozfl

bite7	btst	#7,rege(regs)			; CB 7B Bit e,7
	bra	dozfl

bith7	btst	#7,regh(regs)			; CB 7C Bit h,7
	bra	dozfl

bitl7	btst	#7,regl(regs)			; CB 7D Bit l,7
	bra	dozfl

bithl7	move	regh(regs),d0			; CB 7E Bit (hl),7
	btst	#7,(targbase,d0.l)
	bra	dozfl
*

resa0	bclr	#0,rega			; CB 87 Res a,0
	jmp	(return)

resb0	bclr	#0,regb(regs)			; CB 80 Res b,0
	jmp	(return)

resc0	bclr	#0,regc(regs)			; CB 81 Res c,0
	jmp	(return)

resd0	bclr	#0,regd(regs)			; CB 82 Res d,0
	jmp	(return)

rese0	bclr	#0,rege(regs)			; CB 83 Res e,0
	jmp	(return)

resh0	bclr	#0,regh(regs)			; CB 84 Res h,0
	jmp	(return)

resl0	bclr	#0,regl(regs)			; CB 85 Res l,0
	jmp	(return)

reshl0	move.w	regh(regs),d0			; CB 86 Res (hl),0
	bclr	#0,(targbase,d0.l)
	jmp	(return)

resa1	bclr	#1,rega			; CB 8F Res a,1
	jmp	(return)

resb1	bclr	#1,regb(regs)			; CB 88 Res b,1
	jmp	(return)

resc1	bclr	#1,regc(regs)			; CB 89 Res c,1
	jmp	(return)

resd1	bclr	#1,regd(regs)			; CB 8A Res d,1
	jmp	(return)

rese1	bclr	#1,rege(regs)			; CB 8B Res e,1
	jmp	(return)

resh1	bclr	#1,regh(regs)			; CB 8C Res h,1
	jmp	(return)

resl1	bclr	#1,regl(regs)			; CB 8D Res l,1
	jmp	(return)

reshl1	move.w	regh(regs),d0			; CB 8E Res (hl),1
	bclr	#1,(targbase,d0.l)
	jmp	(return)

resa2	bclr	#2,rega			; CB 97 Res a,2
	jmp	(return)

resb2	bclr	#2,regb(regs)			; CB 90 Res b,2
	jmp	(return)

resc2	bclr	#2,regc(regs)			; CB 91 Res c,2
	jmp	(return)

resd2	bclr	#2,regd(regs)			; CB 92 Res d,2
	jmp	(return)

rese2	bclr	#2,rege(regs)			; CB 93 Res e,2
	jmp	(return)

resh2	bclr	#2,regh(regs)			; CB 94 Res h,2
	jmp	(return)

resl2	bclr	#2,regl(regs)			; CB 95 Res l,2
	jmp	(return)

reshl2	move.w	regh(regs),d0			; CB 96 Res (hl),2
	bclr	#2,(targbase,d0.l)
	jmp	(return)

resa3	bclr	#3,rega			; CB 9F Res a,3
	jmp	(return)

resb3	bclr	#3,regb(regs)			; CB 98 Res b,3
	jmp	(return)

resc3	bclr	#3,regc(regs)			; CB 99 Res c,3
	jmp	(return)

resd3	bclr	#3,regd(regs)			; CB 9A Res d,3
	jmp	(return)

rese3	bclr	#3,rege(regs)			; CB 9B Res e,3
	jmp	(return)

resh3	bclr	#3,regh(regs)			; CB 9C Res h,3
	jmp	(return)

resl3	bclr	#3,regl(regs)			; CB 9D Res l,3
	jmp	(return)

reshl3	move.w	regh(regs),d0			; CB 9E Res (hl),3
	bclr	#3,(targbase,d0.l)
	jmp	(return)

resa4	bclr	#4,rega			; CB A7 Res a,4
	jmp	(return)

resb4	bclr	#4,regb(regs)			; CB A0 Res b,4
	jmp	(return)

resc4	bclr	#4,regc(regs)			; CB A1 Res c,4
	jmp	(return)

resd4	bclr	#4,regd(regs)			; CB A2 Res d,4
	jmp	(return)

rese4	bclr	#4,rege(regs)			; CB A3 Res e,4
	jmp	(return)

resh4	bclr	#4,regh(regs)			; CB A4 Res h,4
	jmp	(return)

resl4	bclr	#4,regl(regs)			; CB A5 Res l,4
	jmp	(return)

reshl4	move.w	regh(regs),d0			; CB A6 Res (hl),4
	bclr	#4,(targbase,d0.l)
	jmp	(return)

resa5	bclr	#5,rega			; CB AF Res a,5
	jmp	(return)

resb5	bclr	#5,regb(regs)			; CB A8 Res b,5
	jmp	(return)

resc5	bclr	#5,regc(regs)			; CB A9 Res c,5
	jmp	(return)

resd5	bclr	#5,regd(regs)			; CB AA Res d,5
	jmp	(return)

rese5	bclr	#5,rege(regs)			; CB AB Res e,5
	jmp	(return)

resh5	bclr	#5,regh(regs)			; CB AC Res h,5
	jmp	(return)

resl5	bclr	#5,regl(regs)			; CB AD Res l,5
	jmp	(return)

reshl5	move.w	regh(regs),d0			; CB AE Res (hl),5
	bclr	#5,(targbase,d0.l)
	jmp	(return)

resa6	bclr	#6,rega			; CB B7 Res a,6
	jmp	(return)

resb6	bclr	#6,regb(regs)			; CB B0 Res b,6
	jmp	(return)

resc6	bclr	#6,regc(regs)			; CB B1 Res c,6
	jmp	(return)

resd6	bclr	#6,regd(regs)			; CB B2 Res d,6
	jmp	(return)

rese6	bclr	#6,rege(regs)			; CB B3 Res e,6
	jmp	(return)

resh6	bclr	#6,regh(regs)			; CB B4 Res h,6
	jmp	(return)

resl6	bclr	#6,regl(regs)			; CB B5 Res l,6
	jmp	(return)

reshl6	move.w	regh(regs),d0			; CB B6 Res (hl),6
	bclr	#6,(targbase,d0.l)
	jmp	(return)

resa7	bclr	#7,rega			; CB BF Res a,7
	jmp	(return)

resb7	bclr	#7,regb(regs)			; CB B8 Res b,7
	jmp	(return)

resc7	bclr	#7,regc(regs)			; CB B9 Res c,7
	jmp	(return)

resd7	bclr	#7,regd(regs)			; CB BA Res d,7
	jmp	(return)

rese7	bclr	#7,rege(regs)			; CB BB Res e,7
	jmp	(return)

resh7	bclr	#7,regh(regs)			; CB BC Res h,7
	jmp	(return)

resl7	bclr	#7,regl(regs)			; CB BD Res l,7
	jmp	(return)

reshl7	move.w	regh(regs),d0			; CB BE Res (hl),7
	bclr	#7,(targbase,d0.l)
	jmp	(return)

seta0	bset	#0,rega			; CB C7 Set a,0
	jmp	(return)

setb0	bset	#0,regb(regs)			; CB C0 Set b,0
	jmp	(return)

setc0	bset	#0,regc(regs)			; CB C1 Set c,0
	jmp	(return)

setd0	bset	#0,regd(regs)			; CB C2 Set d,0
	jmp	(return)

sete0	bset	#0,rege(regs)			; CB C3 Set e,0
	jmp	(return)

seth0	bset	#0,regh(regs)			; CB C4 Set h,0
	jmp	(return)

setl0	bset	#0,regl(regs)			; CB C5 Set l,0
	jmp	(return)

sethl0	move.w	regh(regs),d0			; CB C6 Set (hl),0
	bset	#0,(targbase,d0.l)
	jmp	(return)

seta1	bset	#1,rega			; CB CF Set a,1
	jmp	(return)

setb1	bset	#1,regb(regs)			; CB C8 Set b,1
	jmp	(return)

setc1	bset	#1,regc(regs)			; CB C9 Set c,1
	jmp	(return)

setd1	bset	#1,regd(regs)			; CB CA Set d,1
	jmp	(return)

sete1	bset	#1,rege(regs)			; CB CB Set e,1
	jmp	(return)

seth1	bset	#1,regh(regs)			; CB CC Set h,1
	jmp	(return)

setl1	bset	#1,regl(regs)			; CB CD Set l,1
	jmp	(return)

sethl1	move.w	regh(regs),d0			; CB CE Set (hl),1
	bset	#1,(targbase,d0.l)
	jmp	(return)

seta2	bset	#2,rega			; CB D7 Set a,2
	jmp	(return)

setb2	bset	#2,regb(regs)			; CB D0 Set b,2
	jmp	(return)

setc2	bset	#2,regc(regs)			; CB D1 Set c,2
	jmp	(return)

setd2	bset	#2,regd(regs)			; CB D2 Set d,2
	jmp	(return)

sete2	bset	#2,rege(regs)			; CB D3 Set e,2
	jmp	(return)

seth2	bset	#2,regh(regs)			; CB D4 Set h,2
	jmp	(return)

setl2	bset	#2,regl(regs)			; CB D5 Set l,2
	jmp	(return)

sethl2	move.w	regh(regs),d0			; CB D6 Set (hl),2
	bset	#2,(targbase,d0.l)
	jmp	(return)

seta3	bset	#3,rega			; CB DF Set a,3
	jmp	(return)

setb3	bset	#3,regb(regs)			; CB D8 Set b,3
	jmp	(return)

setc3	bset	#3,regc(regs)			; CB D9 Set c,3
	jmp	(return)

setd3	bset	#3,regd(regs)			; CB DA Set d,3
	jmp	(return)

sete3	bset	#3,rege(regs)			; CB DB Set e,3
	jmp	(return)

seth3	bset	#3,regh(regs)			; CB DC Set h,3
	jmp	(return)

setl3	bset	#3,regl(regs)			; CB DD Set l,3
	jmp	(return)

sethl3	move.w	regh(regs),d0			; CB DE Set (hl),3
	bset	#3,(targbase,d0.l)
	jmp	(return)

seta4	bset	#4,rega			; CB E7 Set a,4
	jmp	(return)

setb4	bset	#4,regb(regs)			; CB E0 Set b,4
	jmp	(return)

setc4	bset	#4,regc(regs)			; CB E1 Set c,4
	jmp	(return)

setd4	bset	#4,regd(regs)			; CB E2 Set d,4
	jmp	(return)

sete4	bset	#4,rege(regs)			; CB E3 Set e,4
	jmp	(return)

seth4	bset	#4,regh(regs)			; CB E4 Set h,4
	jmp	(return)

setl4	bset	#4,regl(regs)			; CB E5 Set l,4
	jmp	(return)

sethl4	move.w	regh(regs),d0			; CB E6 Set (hl),4
	bset	#4,(targbase,d0.l)
	jmp	(return)

seta5	bset	#5,rega			; CB EF Set a,5
	jmp	(return)

setb5	bset	#5,regb(regs)			; CB E8 Set b,5
	jmp	(return)

setc5	bset	#5,regc(regs)			; CB E9 Set c,5
	jmp	(return)

setd5	bset	#5,regd(regs)			; CB EA Set d,5
	jmp	(return)

sete5	bset	#5,rege(regs)			; CB EB Set e,5
	jmp	(return)

seth5	bset	#5,regh(regs)			; CB EC Set h,5
	jmp	(return)

setl5	bset	#5,regl(regs)			; CB ED Set l,5
	jmp	(return)

sethl5	move.w	regh(regs),d0			; CB EE Set (hl),5
	bset	#5,(targbase,d0.l)
	jmp	(return)

seta6	bset	#6,rega			; CB F7 Set a,6
	jmp	(return)

setb6	bset	#6,regb(regs)			; CB F0 Set b,6
	jmp	(return)

setc6	bset	#6,regc(regs)			; CB F1 Set c,6
	jmp	(return)

setd6	bset	#6,regd(regs)			; CB F2 Set d,6
	jmp	(return)

sete6	bset	#6,rege(regs)			; CB F3 Set e,6
	jmp	(return)

seth6	bset	#6,regh(regs)			; CB F4 Set h,6
	jmp	(return)

setl6	bset	#6,regl(regs)			; CB F5 Set l,6
	jmp	(return)

sethl6	move.w	regh(regs),d0			; CB F6 Set (hl),6
	bset	#6,(targbase,d0.l)
	jmp	(return)

seta7	bset	#7,rega			; CB FF Set a,7
	jmp	(return)

setb7	bset	#7,regb(regs)			; CB F8 Set b,7
	jmp	(return)

setc7	bset	#7,regc(regs)			; CB F9 Set c,7
	jmp	(return)

setd7	bset	#7,regd(regs)			; CB FA Set d,7
	jmp	(return)

sete7	bset	#7,rege(regs)			; CB FB Set e,7
	jmp	(return)

seth7	bset	#7,regh(regs)			; CB FC Set h,7
	jmp	(return)

setl7	bset	#7,regl(regs)			; CB FD Set l,7
	jmp	(return)

sethl7	move.w	regh(regs),d0			; CB FE Set (hl),7
	bset	#7,(targbase,d0.l)
	jmp	(return)

*************************************************************************
*									*
*	Z-80 rotate and shift group					*
*									*
*************************************************************************

doflag
	and.w	regcon0f,d1
	move.b	(flagptr,d1.w),regf
	and.w	regcon01,d1
	or.b	d1,regf
	jmp	(return)

rlca	rol.b	#1,rega				; CB 07 Rlc A
	move	sr,d1
	bra	doflag

rrca	ror.b	#1,rega				; CB 0F Rrc A
	move	sr,d1
	bra	doflag

rla	roxr.b	#1,regf				; CB 17 Rl  A
	roxl.b	#1,rega
	move	sr,d1
	bra	doflag

rra	roxr.b	#1,regf				; CB 1F Rr  A
	roxr.b	#1,rega
	move	sr,d1
	bra	doflag

slaa	asl.b	#1,rega				; CB 27 Sla A
	move	sr,d1
	bra	doflag

sraa	asr.b	#1,rega				; CB 2F Sra A
	move	sr,d1
	bra	doflag

srla	lsr.b	#1,rega				; CB 3F Srl A
	move	sr,d1
	bra	doflag

rlcb	move.b	regb(regs),d0			; CB 00 Rlc B
	rol.b	#1,d0
	move	sr,d1
	move.b	d0,regb(regs)
	bra	doflag

rrcb	move.b	regb(regs),d0			; CB 08 Rrc B
	ror.b	#1,d0
	move	sr,d1
	move.b	d0,regb(regs)
	bra	doflag

rlb	move.b	regb(regs),d0			; CB 10 Rl  B
	roxr.b	#1,regf
	roxl.b	#1,d0
	move	sr,d1
	move.b	d0,regb(regs)
	bra	doflag

rrb	move.b	regb(regs),d0			; CB 18 Rr B
	roxr.b	#1,regf
	roxr.b	#1,d0
	move	sr,d1
	move.b	d0,regb(regs)
	bra	doflag

slab	move.b	regb(regs),d0			; CB 20 Sla B
	asl.b	#1,d0
	move	sr,d1
	move.b	d0,regb(regs)
	bra	doflag

srab	move.b	regb(regs),d0			; CB 28 Sra B
	asr.b	#1,d0
	move	sr,d1
	move.b	d0,regb(regs)
	bra	doflag

srlb	move.b	regb(regs),d0			; CB 38 Sra B
	lsr.b	#1,d0
	move	sr,d1
	move.b	d0,regb(regs)
	bra	doflag


rlcc	move.b	regc(regs),d0			; CB 01 Rlc C
	rol.b	#1,d0
	move	sr,d1
	move.b	d0,regc(regs)
	bra	doflag

rrcc	move.b	regc(regs),d0			; CB 09 Rrc C
	ror.b	#1,d0
	move	sr,d1
	move.b	d0,regc(regs)
	bra	doflag

rlc	move.b	regc(regs),d0			; CB 11 Rl  C
	roxr.b	#1,regf
	roxl.b	#1,d0
	move	sr,d1
	move.b	d0,regc(regs)
	bra	doflag

rrc	move.b	regc(regs),d0			; CB 19 Rr C
	roxr.b	#1,regf
	roxr.b	#1,d0
	move	sr,d1
	move.b	d0,regc(regs)
	bra	doflag

slac	move.b	regc(regs),d0			; CB 21 Sla C
	asl.b	#1,d0
	move	sr,d1
	move.b	d0,regc(regs)
	bra	doflag

srac	move.b	regc(regs),d0			; CB 29 Sra C
	asr.b	#1,d0
	move	sr,d1
	move.b	d0,regc(regs)
	bra	doflag

srlc	move.b	regc(regs),d0			; CB 39 Sra C
	lsr.b	#1,d0
	move	sr,d1
	move.b	d0,regc(regs)
	bra	doflag


rlcd	move.b	regd(regs),d0			; CB 02 Rlc D
	rol.b	#1,d0
	move	sr,d1
	move.b	d0,regd(regs)
	bra	doflag

rrcd	move.b	regd(regs),d0			; CB 0A Rrc D
	ror.b	#1,d0
	move	sr,d1
	move.b	d0,regd(regs)
	bra	doflag

rld	move.b	regd(regs),d0			; CB 12 Rl  D
	roxr.b	#1,regf
	roxl.b	#1,d0
	move	sr,d1
	move.b	d0,regd(regs)
	bra	doflag

rrd	move.b	regd(regs),d0			; CB 1A Rr D
	roxr.b	#1,regf
	roxr.b	#1,d0
	move	sr,d1
	move.b	d0,regd(regs)
	bra	doflag

slad	move.b	regd(regs),d0			; CB 22 Sla D
	asl.b	#1,d0
	move	sr,d1
	move.b	d0,regd(regs)
	bra	doflag

srad	move.b	regd(regs),d0			; CB 2A Sra D
	asr.b	#1,d0
	move	sr,d1
	move.b	d0,regd(regs)
	bra	doflag

srld	move.b	regd(regs),d0			; CB 3A Sra D
	lsr.b	#1,d0
	move	sr,d1
	move.b	d0,regd(regs)
	bra	doflag


rlce	move.b	rege(regs),d0			; CB 03 Rlc E
	rol.b	#1,d0
	move	sr,d1
	move.b	d0,rege(regs)
	bra	doflag

rrce	move.b	rege(regs),d0			; CB 0B Rrc E
	ror.b	#1,d0
	move	sr,d1
	move.b	d0,rege(regs)
	bra	doflag

rle	move.b	rege(regs),d0			; CB 13 Rl  E
	roxr.b	#1,regf
	roxl.b	#1,d0
	move	sr,d1
	move.b	d0,rege(regs)
	bra	doflag

rre	move.b	rege(regs),d0			; CB 1B Rr E
	roxr.b	#1,regf
	roxr.b	#1,d0
	move	sr,d1
	move.b	d0,rege(regs)
	bra	doflag

slae	move.b	rege(regs),d0			; CB 23 Sla E
	asl.b	#1,d0
	move	sr,d1
	move.b	d0,rege(regs)
	bra	doflag

srae	move.b	rege(regs),d0			; CB 2B Sra E
	asr.b	#1,d0
	move	sr,d1
	move.b	d0,rege(regs)
	bra	doflag

srle	move.b	rege(regs),d0			; CB 3B Sra E
	lsr.b	#1,d0
	move	sr,d1
	move.b	d0,rege(regs)
	bra	doflag

rlch	move.b	regh(regs),d0			; CB 04 Rlc H
	rol.b	#1,d0
	move	sr,d1
	move.b	d0,regh(regs)
	bra	doflag

rrch	move.b	regh(regs),d0			; CB 0C Rrc H
	ror.b	#1,d0
	move	sr,d1
	move.b	d0,regh(regs)
	bra	doflag

rlh	move.b	regh(regs),d0			; CB 14 Rl  H
	roxr.b	#1,regf
	roxl.b	#1,d0
	move	sr,d1
	move.b	d0,regh(regs)
	bra	doflag

rrh	move.b	regh(regs),d0			; CB 1C Rr H
	roxr.b	#1,regf
	roxr.b	#1,d0
	move	sr,d1
	move.b	d0,regh(regs)
	bra	doflag

slah	move.b	regh(regs),d0			; CB 24 Sla H
	asl.b	#1,d0
	move	sr,d1
	move.b	d0,regh(regs)
	bra	doflag

srah	move.b	regh(regs),d0			; CB 2C Sra H
	asr.b	#1,d0
	move	sr,d1
	move.b	d0,regh(regs)
	bra	doflag

srlh	move.b	regh(regs),d0			; CB 3C Sra H
	lsr.b	#1,d0
	move	sr,d1
	move.b	d0,regh(regs)
	bra	doflag


rlcl	move.b	regl(regs),d0			; CB 05 Rlc L
	rol.b	#1,d0
	move	sr,d1
	move.b	d0,regl(regs)
	bra	doflag

rrcl	move.b	regl(regs),d0			; CB 0D Rrc L
	ror.b	#1,d0
	move	sr,d1
	move.b	d0,regl(regs)
	bra	doflag

rll	move.b	regl(regs),d0			; CB 15 Rl  L
	roxr.b	#1,regf
	roxl.b	#1,d0
	move	sr,d1
	move.b	d0,regl(regs)
	bra	doflag

rrl	move.b	regl(regs),d0			; CB 1D Rr L
	roxr.b	#1,regf
	roxr.b	#1,d0
	move	sr,d1
	move.b	d0,regl(regs)
	bra	doflag

slal	move.b	regl(regs),d0			; CB 25 Sla L
	asl.b	#1,d0
	move	sr,d1
	move.b	d0,regl(regs)
	bra	doflag

sral	move.b	regl(regs),d0			; CB 2D Sra L
	asr.b	#1,d0
	move	sr,d1
	move.b	d0,regl(regs)
	bra	doflag

srll	move.b	regl(regs),d0			; CB 3D Sra L 
	lsr.b	#1,d0
	move	sr,d1
	move.b	d0,regc(regs)
	bra	doflag


rlcm	move.w	regh(regs),d0			; CB 06 Rlc M
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(a0),d0
	rol.b	#1,d0
	move	sr,d1
	move.b	d0,(a0)
	bra	doflag

rrcm	move.w	regh(regs),d0			; CB 0E Rrc M
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(a0),d0
	ror.b	#1,d0
	move	sr,d1
	move.b	d0,(a0)
	bra	doflag

rlm	move.w	regh(regs),d0			; CB 16 Rl  M
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(a0),d0
	roxr.b	#1,regf
	roxl.b	#1,d0
	move	sr,d1
	move.b	d0,(a0)
	bra	doflag

rrm	move.w	regh(regs),d0			; CB 1E Rr M
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(a0),d0
	roxr.b	#1,regf
	roxr.b	#1,d0
	move	sr,d1
	move.b	d0,(a0)
	bra	doflag

slam	move.w	regh(regs),d0			; CB 26 Sla M
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(a0),d0
	asl.b	#1,d0
	move	sr,d1
	move.b	d0,(a0)
	bra	doflag

sram	move.w	regh(regs),d0			; CB 2E Sra M
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(a0),d0
	asr.b	#1,d0
	move	sr,d1
	move.b	d0,(a0)
	bra	doflag

srlm	move.w	regh(regs),d0			; CB 3E Sra M 
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(a0),d0
	lsr.b	#1,d0
	move	sr,d1
	move.b	d0,(a0)
	bra	doflag


	end
Sra M 
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(a0),d0
	lsr.b