*********************************************************************
*									 *
*	 This file contains the	special	Z-80 simulation	routines	 *
*	 for opcodes with the pre-byte of DD				 *
*									 *
*************************************************************************

	 globl preDD
	 xdef mloop,illegl

return	  equ @16,r	 ; JMP (return)	is fast	return to MLOOP.
pseudopc equ @15,r	 ; 8080's PC is	register A5.
opptr	  equ @14,r	 ; Pointer to opcode dispatch table.
pseudosp equ @13,r	 ; 8080's SP is	register A3.
flagptr  equ @12,r	 ; Pointer to 8080's flag lookup table is A2.
targbase equ @11,r	 ; Pointer to 8080's address space is A1.
regs	  equ @11,r	 ; Base	pointer	to 8080's registers is A1.

regcon0e equ 7,r	 ; Register based constant #$E (for speed).
regcon01 equ 6,r	 ; Register based constant #$1.
regcon0f equ 5,r	 ; Register based constant #$F.
regconff equ 4,r	 ; Register based constant #$FF.
regf	  equ 3,r	 ; 8080's Flags
rega	  equ 2,r	 ; 8080's Accumulator

regiy	 equ -$c
regix	 equ -$a
regop3	 equ -9
regb	 equ -8		 ; Offsets from	register base pointer for
regc	 equ -7		 ; 8080's pseudo-registers.
regd	 equ -6		 ; A & F are in	Data Registers.
rege	 equ -5		 ; Pseudo-PC is	kept in	an Address Register.
regh	 equ -4
regl	 equ -3
regop1	 equ -2		 ; Operand 1 for DAA storage
regop2	 equ -1		 ;    "	   2  "	  "	"


	 data
	 page
*************************************************************************
*									 *
*	 Opcode	dispatch table.	 One longword entry per	opcode of the	 *
*	 target	(Z-80) processor, including illegals.			 *
*									 *
*************************************************************************

	 even
	 data
DDoptab  dc.l 0,0,0,0,0,0,0,0		 ; DD00
	 dc.l 0,addixbc,0,0,0,0,0,0
	 dc.l 0,0,0,0,0,0,0,0		 ; DD10
	 dc.l 0,addixde,0,0,0,0,0,0
	 dc.l 0,ldixi,sixd,incix,0,0,0,0		 ; DD20
	 dc.l 0,addixix,ldixd,decix,0,0,0,0
	 dc.l 0,0,0,0,incixd,decixd,ldixdi,0		 ; DD30
	 dc.l 0,addixsp,0,0,0,0,0,0
	 dc.l 0,0,0,0,0,0,ldbixd,0		 ; DD40
	 dc.l 0,0,0,0,0,0,ldcixd,0
	 dc.l 0,0,0,0,0,0,lddixd,0		 ; DD50
	 dc.l 0,0,0,0,0,0,ldeixd,0
	 dc.l 0,0,0,0,0,0,ldhixd,0		 ; DD60
	 dc.l 0,0,0,0,0,0,ldlixd,0
	 dc.l ldixdb,ldixdc,ldixdd,ldixde,ldixdh,ldixdl,0,ldixda ; DD70
	 dc.l 0,0,0,0,0,0,ldaixd,0
	 dc.l 0,0,0,0,0,0,addixd,0		 ; DD80
	 dc.l 0,0,0,0,0,0,adcixd,0
	 dc.l 0,0,0,0,0,0,subixd,0		 ; DD90
	 dc.l 0,0,0,0,0,0,sbcixd,0
	 dc.l 0,0,0,0,0,0,andixd,0		 ; DDA0
	 dc.l 0,0,0,0,0,0,xorixd,0
	 dc.l 0,0,0,0,0,0,orixd,0		 ; DDB0
	 dc.l 0,0,0,0,0,0,cpixd,0
	 dc.l 0,0,0,0,0,0,0,0		 ; DDC0
	 dc.l 0,0,0,0,0,0,0,0
	 dc.l 0,0,0,0,0,0,0,0		 ; DDD0
	 dc.l 0,0,0,0,0,0,0,0
	 dc.l 0,popix,0,exspix,0,pushix,0,0		 ; DDE0
	 dc.l 0,pcix,0,0,0,0,0,0
	 dc.l 0,0,0,0,0,0,0,0		 ; DDF0
	 dc.l 0,ldspix,0,0,0,0,0,0

	 page
	 text
preDD	 moveq #0,d1			 ; Zero-fill high bits.
	 move.b	(pseudopc)+,d1		 ; Grab	next opcode.
	 asl #2,d1
	 lea.l DDoptab,a0
	 move.l	0(a0,d1.w),-(sp)	 ; Do the operation.
	 beq illgDD
	 rts

illgDD	 move.l	(sp)+,d1		 ; Trash the address,
	 dec.l pseudopc			 ; fix PPC for ILLEGAL.
	 bra illegl


*************************************************************************
*									*
*	Z-80 jumps							*
*									*
*************************************************************************

pcix	move.w	regix(regs),d0			; DD E9 Jp (IX)
	move.l	d0,pseudopc
	add.l	targbase,pseudopc
	jmp	(return)


*************************************************************************
*									*
*	Z-80 8-bit loads						*
*									*
*************************************************************************

ldaixd	move.w	regix(regs),d0			; DD 7E Ld A,(IX+d)
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	(a0,d0.w),rega
	jmp	(return)

ldbixd	move.w	regix(regs),d0			; DD 46 Ld B,(IX+d)
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	(a0,d0.w),regb(regs)
	jmp	(return)

ldcixd	move.w	regix(regs),d0			; DD 4E Ld C,(IX+d)
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	(a0,d0.w),regc(regs)
	jmp	(return)

lddixd	move.w	regix(regs),d0			; DD 56 Ld D,(IX+d)
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	(a0,d0.w),regd(regs)
	jmp	(return)

ldeixd	move.w	regix(regs),d0			; DD 5E Ld E,(IX+d)
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	(a0,d0.w),rege(regs)
	jmp	(return)

ldhixd	move.w	regix(regs),d0			; DD 66 Ld H,(IX+d)
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	(a0,d0.w),regh(regs)
	jmp	(return)

ldlixd	move.w	regix(regs),d0			; DD 6E Ld L,(IX+d)
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	(a0,d0.w),regl(regs)
	jmp	(return)



ldixda	move.w	regix(regs),d0			; DD 77 Ld (IX+d),A
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	rega,(a0,d0.w)
	jmp	(return)

ldixdb	move.w	regix(regs),d0			; DD 70 Ld (IX+d),B
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	regb(regs),(a0,d0.w)
	jmp	(return)

ldixdc	move.w	regix(regs),d0			; DD 71 Ld (IX+d),C
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	regc(regs),(a0,d0.w)
	jmp	(return)

ldixdd	move.w	regix(regs),d0			; DD 72 Ld (IX+d),D
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	regd(regs),(a0,d0.w)
	jmp	(return)

ldixde	move.w	regix(regs),d0			; DD 73 Ld (IX+d),E
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	rege(regs),(a0,d0.w)
	jmp	(return)

ldixdh	move.w	regix(regs),d0			; DD 74 Ld (IX+d),H
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	regh(regs),(a0,d0.w)
	jmp	(return)

ldixdl	move.w	regix(regs),d0			; DD 75 Ld (IX+d),L
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	regl(regs),(a0,d0.w)
	jmp	(return)



ldixdi	move.w	regix(regs),d0			; DD 36 Ld (IX+d),n
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	(pseudopc)+,(a0,d0.w)
	jmp	(return)


*************************************************************************
*									*
*	Z-80 16 bit load group						*
*									*
*************************************************************************

pushix	move.b	regix(regs),-(pseudosp)		; DD E5 Push IX
	move.b	regix+1(regs),-(pseudosp)
	jmp	(return)

popix	move.b	(pseudosp)+,regix+1(regs)	; DD E1 Pop IX
	move.b	(pseudosp)+,regix(regs)
	jmp	(return)

ldixi	move.b	(pseudopc)+,regix+1(regs)	; DD 21 Ld IX,nn
	move.b	(pseudopc)+,regix(regs)
	jmp	(return)

ldixd	move.b	1(pseudopc),-(sp)		; DD 21 Ld IX,(nn)
	move.w	(sp)+,d0
	move.b	(pseudopc),d0
	addq.l	#2,pseudopc
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(a0)+,regix+1(regs)
	move.b	(a0),regix(regs)
	jmp	(return)

sixd	move.b	1(pseudopc),-(sp)		; DD 22 Ld (nn),IX
	move.w	(sp)+,d0
	move.b	(pseudopc),d0
	addq.l	#2,pseudopc
	move.l	d0,a0
	add.l	targbase,a0
	move.b	regix+1(regs),(a0)+
	move.b	regix(regs),(a0)
	jmp	(return)

ldspix	move.w	regix(regs),d0			; DD F9 Ld SP,IX
	move.l	d0,pseudosp
	add.l	targbase,pseudosp
	jmp	(return)

exspix	move.w	regix(regs),d0			; DD E3 Ex (SP),IX
	move.b	(pseudosp),regix+1(regs)
	move.b	1(pseudosp),regix(regs)
	move.b	d0,(pseudosp)
	move.w	d0,-(sp)
	move.b	(sp)+,1(pseudosp)
	jmp	(return)

************************************************************************
*									*
*	Z-80 8-bit arithmetic						*
*									*
************************************************************************

addixd	move.w	regix(regs),d0			; DD 86 Add A,(IX+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	move.b	(targbase,d0.l),d0
	move.b	d0,regop1(regs)
	move.b	rega,regop2(regs)
	move.b	regcon0e,regop3(regs)
	add.b	d0,rega
	move	sr,d0
	and.w	regcon0f,d0
	move.b	(flagptr,d0.w),regf
	jmp	(return)

adcixd	move.w	regix(regs),d0			; DD 8E Adc A,(IX+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	move.b	(targbase,d0.l),d0
	move.b	regf,regop3(regs)
	asr.b	#1,regf
	move.b	d0,regop1(regs)
	move.b	rega,regop2(regs)
	moveq	#0,d1
	addx.b	d0,rega
	move	sr,d0
	and.w	regcon0f,d0
	move.b	(flagptr,d0.w),regf
	jmp	(return)

subixd	move.w	regix(regs),d0			; DD 96 Sub A,(IX+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	sub.b	(targbase,d0.l),rega
	move	sr,d0
	and.w	regcon0f,d0
	move.b	(flagptr,d0.w),regf
	jmp	(return)

sbcixd	move.w	regix(regs),d0			; DD 9E Sbc A,(IX+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	move.b	(targbase,d0.l),d0
	asr.b	#1,regf
	subx.b	d0,rega
	move	sr,d0
	and.w	regcon0f,d0
	move.b	(flagptr,d0.w),regf
	jmp	(return)

andixd	move.w	regix(regs),d0			; DD A6 And A,(IX+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	and.b	(targbase,d0.l),rega
	move.b	rega,d0
	and.w	regconff,d0
	move.b	16(flagptr,d0.w),regf
	jmp	(return)

xorixd	move.w	regix(regs),d0			; DD AE Xor A,(IX+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	move.b	(targbase,d0.l),d0
	eor.b	d0,rega
	move.b	rega,d0
	and.w	regconff,d0
	move.b	16(flagptr,d0.w),regf
	jmp	(return)

orixd	move.w	regix(regs),d0			; DD B6 Or A,(IX+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	or.b	(targbase,d0.l),rega
	move.b	rega,d0
	and.w	regconff,d0
	move.b	16(flagptr,d0.w),regf
	jmp	(return)

cpixd	move.w	regix(regs),d0			; DD BE Cp A,(IX+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	cmp.b	(targbase,d0.l),rega
	move	sr,d0
	and.w	regcon0f,d0
	move.b	(flagptr,d0.w),regf
	jmp	(return)

incixd	move.w	regix(regs),d0			; DD 34 Inc (IX+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	inc.b	(targbase,d0.l)
	move	sr,d0
	and.w	regcon0e,d0
	and.w	regcon01,regf
	or.b	(flagptr,d0.w),regf
	jmp	(return)

decixd	move.w	regix(regs),d0			; DD 35 Dec (IX+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	dec.b	(targbase,d0.l)
	move	sr,d0
	and.w	regcon0e,d0
	and.w	regcon01,regf
	or.b	(flagptr,d0.w),regf
	jmp	(return)

*************************************************************************
*									*
*	Z-80 16-bit arithmetic						*
*									*
*************************************************************************

doadd	add.w	d0,regix(regs)
	bcs	cy1
	bclr	#0,regf
	jmp 	(return)
cy1	bset	#0,regf
	jmp	(return)

addixbc	move.w	regb(regs),d0			; DD 09 Add IX,BC
	bra	doadd

addixde	move.w	regd(regs),d0			; DD 19 Add IX,DE
	bra	doadd

addixsp	move.l	pseudosp,d0			; DD 39 Add IX,SP
	sub.l	targbase,d0
	bra	doadd

addixix	move.w	regix(regs),d0			; DD 29 Add IX,IX
	bra	doadd

incix	inc.w	regix(regs)			; DD 23 Inc IX
	jmp	(return)

decix	dec.w	regix(regs)			; DD 2B Dec IX
	jmp	(return)

	end


incix	inc.w	regix(regs)			; DD 23 Inc IX
	jmp	(return)
