*********************************************************************
*									 *
*	 This file contains the	special	Z-80 simulation	routines and	 *
*	 the Morrow HDC/DMA support routines.				 *
*									 *
*************************************************************************

	 globl preFD
	 xdef mloop,illegl

return	  equ @16,r	 ; JMP (return)	is fast	return to MLOOP.
pseudopc equ @15,r	 ; 8080's PC is	register A5.
opptr	  equ @14,r	 ; Pointer to opcode dispatch table.
pseudosp equ @13,r	 ; 8080's SP is	register A3.
flagptr  equ @12,r	 ; Pointer to 8080's flag lookup table is A2.
targbase equ @11,r	 ; Pointer to 8080's address space is A1.
regs	  equ @11,r	 ; Base	pointer	to 8080's registers is A1.

regcon0e equ 7,r	 ; Register based constant #$E (for speed).
regcon01 equ 6,r	 ; Register based constant #$1.
regcon0f equ 5,r	 ; Register based constant #$F.
regconff equ 4,r	 ; Register based constant #$FF.
regf	  equ 3,r	 ; 8080's Flags
rega	  equ 2,r	 ; 8080's Accumulator

regiy	 equ -$c
regix	 equ -$a
regop3	 equ -9
regb	 equ -8		 ; Offsets from	register base pointer for
regc	 equ -7		 ; 8080's pseudo-registers.
regd	 equ -6		 ; A & F are in	Data Registers.
rege	 equ -5		 ; Pseudo-PC is	kept in	an Address Register.
regh	 equ -4
regl	 equ -3
regop1	 equ -2		 ; Operand 1 for DAA storage
regop2	 equ -1		 ;    "	   2  "	  "	"


	 data
	 page
*************************************************************************
*									 *
*	 Opcode	dispatch table.	 One longword entry per	opcode of the	 *
*	 target	(Z-80) processor, including illegals.			 *
*									 *
*************************************************************************
*									 *
*	 Only a	few of the most	popular	instructions are simulated.	 *
*	 Support for the Z-80 Block move instructions is provided	 *
*	 as the	flags for this simulation resemble those of the	Z-80	 *
*	 rather	than the 8080.	Certain	packages (notably BDS-C) check	 *
*	 the flags and mistakenly assume a Z-80, then use LDIR/LDDR.	 *
*	 Therefore, minimal Z-80 support is provided for these		 *
*	 instructions.	By no means is this a complete simulation	 *
*	 of the	Z-80.							 *
*									 *
*************************************************************************


	 even
	 data
FDoptab  dc.l 0,0,0,0,0,0,0,0		 ; FD00
	 dc.l 0,addiybc,0,0,0,0,0,0
	 dc.l 0,0,0,0,0,0,0,0		 ; FD10
	 dc.l 0,addiyde,0,0,0,0,0,0
	 dc.l 0,ldiyi,0,inciy,0,0,0,0		 ; FD20
	 dc.l 0,addiyiy,ldiyd,deciy,0,0,0,0
	 dc.l 0,0,0,0,inciyd,deciyd,ldiydi,0		 ; FD30
	 dc.l 0,addiysp,0,0,0,0,0,0
	 dc.l 0,0,0,0,0,0,ldbiyd,0		 ; FD40
	 dc.l 0,0,0,0,0,0,ldciyd,0
	 dc.l 0,0,0,0,0,0,lddiyd,0		 ; FD50
	 dc.l 0,0,0,0,0,0,ldeiyd,0
	 dc.l 0,0,0,0,0,0,ldhiyd,0		 ; FD60
	 dc.l 0,0,0,0,0,0,ldliyd,0
	 dc.l ldiydb,ldiydc,ldiydd,ldiyde,ldiydh,ldiydl,0,ldiyda ; FD70
	 dc.l 0,0,0,0,0,0,ldaiyd,0
	 dc.l 0,0,0,0,0,0,addiyd,0		 ; FD80
	 dc.l 0,0,0,0,0,0,adciyd,0
	 dc.l 0,0,0,0,0,0,subiyd,0		 ; FD90
	 dc.l 0,0,0,0,0,0,sbciyd,0
	 dc.l 0,0,0,0,0,0,andiyd,0		 ; FDA0
	 dc.l 0,0,0,0,0,0,xoriyd,0
	 dc.l 0,0,0,0,0,0,oriyd,0		 ; FDB0
	 dc.l 0,0,0,0,0,0,cpiyd,0
	 dc.l 0,0,0,0,0,0,0,0		 ; FDC0
	 dc.l 0,0,0,0,0,0,0,0
	 dc.l 0,0,0,0,0,0,0,0		 ; FDD0
	 dc.l 0,0,0,0,0,0,0,0
	 dc.l 0,popiy,0,0,0,pushiy,0,0		 ; FDE0
	 dc.l 0,pciy,0,0,0,0,0,0
	 dc.l 0,0,0,0,0,0,0,0		 ; FDF0
	 dc.l 0,ldspiy,0,0,0,0,0,0

	 page
	 text
preFD	 moveq #0,d1			 ; Zero-fill high bits.
	 move.b	(pseudopc)+,d1		 ; Grab	next opcode.
	 asl #2,d1
	 lea.l FDoptab,a0
	 move.l	0(a0,d1.w),-(sp)	 ; Do the operation.
	 beq illgFD
	 rts

illgFD	 move.l	(sp)+,d1		 ; Trash the address,
	 dec.l pseudopc			 ; fix PPC for ILLEGAL.
	 bra illegl


*************************************************************************
*									*
*	Z-80 jumps							*
*									*
*************************************************************************

pciy	move.w	regiy(regs),d0			; FD E9 Jp (IY)
	move.l	d0,pseudopc
	add.l	targbase,pseudopc
	jmp	(return)

*************************************************************************
*									*
*	Z-80 8-bit loads						*
*									*
*************************************************************************


ldaiyd	move.w	regiy(regs),d0			; FD 7E Ld A,(IY+d)
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	(a0,d0.w),rega
	jmp	(return)

ldbiyd	move.w	regiy(regs),d0			; FD 46 Ld B,(IY+d)
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	(a0,d0.w),regb(regs)
	jmp	(return)

ldciyd	move.w	regiy(regs),d0			; FD 4E Ld C,(IY+d)
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	(a0,d0.w),regc(regs)
	jmp	(return)

lddiyd	move.w	regiy(regs),d0			; FD 56 Ld D,(IY+d)
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	(a0,d0.w),regd(regs)
	jmp	(return)

ldeiyd	move.w	regiy(regs),d0			; FD 5E Ld E,(IY+d)
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	(a0,d0.w),rege(regs)
	jmp	(return)

ldhiyd	move.w	regiy(regs),d0			; FD 66 Ld H,(IY+d)
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	(a0,d0.w),regh(regs)
	jmp	(return)

ldliyd	move.w	regiy(regs),d0			; FD 6E Ld L,(IY+d)
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	(a0,d0.w),regl(regs)
	jmp	(return)


ldiyda	move.w	regiy(regs),d0			; FD 77 Ld (IY+d),A
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	rega,(a0,d0.w)
	jmp	(return)

ldiydb	move.w	regiy(regs),d0			; FD 70 Ld (IY+d),B
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	regb(regs),(a0,d0.w)
	jmp	(return)

ldiydc	move.w	regiy(regs),d0			; FD 71 Ld (IY+d),C
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	regc(regs),(a0,d0.w)
	jmp	(return)

ldiydd	move.w	regiy(regs),d0			; FD 72 Ld (IY+d),D
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	regd(regs),(a0,d0.w)
	jmp	(return)

ldiyde	move.w	regiy(regs),d0			; FD 73 Ld (IY+d),E
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	rege(regs),(a0,d0.w)
	jmp	(return)

ldiydh	move.w	regiy(regs),d0			; FD 74 Ld (IY+d),H
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	regh(regs),(a0,d0.w)
	jmp	(return)

ldiydl	move.w	regiy(regs),d0			; FD 75 Ld (IY+d),L
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	regl(regs),(a0,d0.w)
	jmp	(return)

ldiydi	move.w	regiy(regs),d0			; FD 36 Ld (IY+d),n
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(pseudopc)+,d0
	ext.w	d0
	move.b	(pseudopc)+,(a0,d0.w)
	jmp	(return)


*************************************************************************
*									*
*	Z-80 16 bit load group						*
*									*
*************************************************************************

pushiy	move.b	regiy(regs),-(pseudosp)		; FD E5 Push IY
	move.b	regiy+1(regs),-(pseudosp)
	jmp	(return)

popiy	move.b	(pseudosp)+,regiy+1(regs)	; FD E1 Pop IY
	move.b	(pseudosp)+,regiy(regs)
	jmp	(return)

ldiyi	move.b	(pseudopc)+,regiy+1(regs)	; FD 21 Ld IY,nn
	move.b	(pseudopc)+,regiy(regs)
	jmp	(return)

ldiyd	move.b	1(pseudopc),-(sp)		; FD 21 Ld IY,(nn)
	move.w	(sp)+,d0
	move.b	(pseudopc),d0
	addq.l	#2,pseudopc
	move.l	d0,a0
	add.l	targbase,a0
	move.b	(a0)+,regiy+1(regs)
	move.b	(a0),regiy(regs)
	jmp	(return)


siyd	move.b	1(pseudopc),-(sp)		; FD 22 Ld (nn),IY
	move.w	(sp)+,d0
	move.b	(pseudopc),d0
	addq.l	#2,pseudopc
	move.l	d0,a0
	add.l	targbase,a0
	move.b	regiy+1(regs),(a0)+
	move.b	regiy(regs),(a0)
	jmp	(return)



ldspiy	move.w	regiy(regs),d0			; FD F9 Ld SP,IY
	move.l	d0,pseudosp
	add.l	targbase,pseudosp
	jmp	(return)

exspiy	move.w	regiy(regs),d0			; FD E3 Ex (SP),IY
	move.b	(pseudosp),regix+1(regs)
	move.b	1(pseudosp),regix(regs)
	move.b	d0,(pseudosp)
	move.w	d0,-(sp)
	move.b	(sp)+,1(pseudosp)
	jmp	(return)

************************************************************************
*									*
*	Z-80 8-bit arithmetic						*
*									*
************************************************************************

addiyd	move.w	regiy(regs),d0			; FD 86 Add A,(IY+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	move.b	(targbase,d0.l),d0
	move.b	d0,regop1(regs)
	move.b	rega,regop2(regs)
	move.b	regcon0e,regop3(regs)
	add.b	d0,rega
	move	sr,d0
	and.w	regcon0f,d0
	move.b	(flagptr,d0.w),regf
	jmp	(return)

adciyd	move.w	regiy(regs),d0			; FD 8E Adc A,(IY+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	move.b	(targbase,d0.l),d0
	move.b	regf,regop3(regs)
	asr.b	#1,regf
	move.b	d0,regop1(regs)
	move.b	rega,regop2(regs)
	moveq	#0,d1
	addx.b	d0,rega
	move	sr,d0
	and.w	regcon0f,d0
	move.b	(flagptr,d0.w),regf
	jmp	(return)

subiyd	move.w	regiy(regs),d0			; FD 96 Sub A,(IY+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	sub.b	(targbase,d0.l),rega
	move	sr,d0
	and.w	regcon0f,d0
	move.b	(flagptr,d0.w),regf
	jmp	(return)

sbciyd	move.w	regiy(regs),d0			; FD 9E Sbc A,(IY+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	move.b	(targbase,d0.l),d0
	asr.b	#1,regf
	subx.b	d0,rega
	move	sr,d0
	and.w	regcon0f,d0
	move.b	(flagptr,d0.w),regf
	jmp	(return)

andiyd	move.w	regiy(regs),d0			; FD A6 And A,(IY+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	and.b	(targbase,d0.l),rega
	move.b	rega,d0
	and.w	regconff,d0
	move.b	16(flagptr,d0.w),regf
	jmp	(return)

xoriyd	move.w	regiy(regs),d0			; FD AE Xor A,(IY+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	move.b	(targbase,d0.l),d0
	eor.b	d0,rega
	move.b	rega,d0
	and.w	regconff,d0
	move.b	16(flagptr,d0.w),regf
	jmp	(return)

oriyd	move.w	regiy(regs),d0			; FD B6 Or A,(IY+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	or.b	(targbase,d0.l),rega
	move.b	rega,d0
	and.w	regconff,d0
	move.b	16(flagptr,d0.w),regf
	jmp	(return)

cpiyd	move.w	regiy(regs),d0			; FD BE Cp A,(IY+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	cmp.b	(targbase,d0.l),rega
	move	sr,d0
	and.w	regcon0f,d0
	move.b	(flagptr,d0.w),regf
	jmp	(return)

inciyd	move.w	regiy(regs),d0			; FD 34 Inc (IY+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	inc.b	(targbase,d0.l)
	move	sr,d0
	and.w	regcon0e,d0
	and.w	regcon01,regf
	or.b	(flagptr,d0.w),regf
	jmp	(return)

deciyd	move.w	regiy(regs),d0			; FD 35 Dec (IY+d)
	move.b	(pseudopc)+,d1
	ext.w	d1
	add.w	d1,d0
	dec.b	(targbase,d0.l)
	move	sr,d0
	and.w	regcon0e,d0
	and.w	regcon01,regf
	or.b	(flagptr,d0.w),regf
	jmp	(return)

*************************************************************************
*									*
*	Z-80 16-bit arithmetic						*
*									*
*************************************************************************

doadd	add.w	d0,regiy(regs)
	bcs	cy1
	bclr	#0,regf
	jmp 	(return)
cy1	bset	#0,regf
	jmp	(return)

addiybc	move.w	regb(regs),d0			; FD 09 Add IY,BC
	bra	doadd

addiyde	move.w	regd(regs),d0			; FD 19 Add IY,DE
	bra	doadd

addiysp	move.l	pseudosp,d0			; FD 39 Add IY,SP
	sub.l	targbase,d0
	bra	doadd

addiyiy	move.w	regix(regs),d0			; FD 29 Add IY,IY
	bra	doadd

inciy	inc.w	regiy(regs)			; FD 23 Inc IY
	jmp	(return)

deciy	dec.w	regiy(regs)			; FD 2B Dec IY
	jmp	(return)

	end


inciy	inc.w	regiy(regs)			; FD 23 Inc IY
	jmp	(return)

deciy	dec.w	regiy(regs)			; FD 2B Dec IY
	jmp	(retu